`timescale 1ns / 1ps

module top(input clk, input rst, input btnIn, input turbo, input hilo,
               output [7:0] lines, output [3:0] anodes, output [7:0] leds);
               
  wire [31:0] addr, data_in, data_out;
  wire WE, RE;
  wire btn_clk, div_clk;
  wire [31:0] magic_value;
  
  button btn(clk, btnIn, btn_clk);
  divider div(clk, rst, div_clk);
  
  memory mem(clk, rst, data_out, addr, RE, WE, data_in, magic_value);
  y86_seq y86(btn_clk || (turbo && div_clk), rst, addr, data_in, data_out, WE, RE, leds); 
  
  showhex sh(clk, hilo, magic_value, lines, anodes);
  
endmodule
