//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//-- This confidential and proprietary software may be used only as authorized 
//-- by a licensing agreement from ESD University of Verona - EDALab s.r.l.                      
//--                                                                            
//--                                                                           
//-- Title:             Multimedia System Design Developement
//-- Project:           V-CLIP 1.0
//--    
//-- 
//-- File:              b01_UT.cpp
//-- Author:            Nicola Bombieri
//-- Date:              29 November 2005 
//-- Description:       UT b01 module
//-- 
//-- Mod History: $Log: $
//                                                                            
//----------------------------------------------------------------------------
//-- RCS Version:  $Id: $                                           
//----------------------------------------------------------------------------

#include "b01_UT.h"

// DATA TYPE DEFINITIONS

// Added for the simulation of abstracted ADPCM module.
struct iostruct {
	//nuovi
	bool line1;
	bool line2;
	bool outp;
	bool overflw;
	
};

//typedef unsigned int ADDRESS_TYPE;

#define READ_ADDR 1
#define WRITE_ADDR 2
#define B01_ADDR 5

SC_MODULE(b01_UT)
{
	iostruct ioDataStruct;
	
	int stato;
	
	void process();
	void end_of_elaboration();
	
	SC_CTOR(b01_UT)
	{
		SC_THREAD(process);
	}  
};

int tmp;

// FUNCTIONALITY SIDE:
//****************
void b01_UT::process()
{
	while(true){
	#ifdef _DEBUG
	cout<<"b01 stato = "<<stato<<endl;
	#endif

		switch (stato)
		{
		case 0:
			if ((ioDataStruct.line1 == true) && (ioDataStruct.line2 == true)) 
			{
				stato = 4; 
			}
			else 
			{
				stato = 1;
			}
			ioDataStruct.outp = (ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = false;
			return;
			break;
		case 3:
			if ((ioDataStruct.line1 == true) && (ioDataStruct.line2 == true)) 
			{
				stato = 4; 
			}
			else 
			{
				stato = 1;
			}
			ioDataStruct.outp = (ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = true;
			return;
			break;
		case 1:
			if ((ioDataStruct.line1 == true) && (ioDataStruct.line2 == true)) {
							stato = 5; 
			}
			else {
				stato = 2;
			}
			ioDataStruct.outp = (ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = false;
			return;
			break;
		case 4:
			if ((ioDataStruct.line1 == true) || (ioDataStruct.line2 == true)) {
							stato = 5; 
			}
			else {
				stato = 2;
			}
			ioDataStruct.outp = ~(ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = false;
			return;
			break;
		case 2:
			if ((ioDataStruct.line1 == true) && (ioDataStruct.line2 == true)) {
							stato = 7; 
			}
			else {
				stato = 6;
			}
			ioDataStruct.outp = (ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = false;
			return;
			break;
		case 5:
			if ((ioDataStruct.line1 == true) || (ioDataStruct.line2 == true)) {
							stato = 7; 
			}
			else {
				stato = 6;
			} 
			ioDataStruct.outp = ~(ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = false;
			return;
			break;
		case 6:
			if ((ioDataStruct.line1 == true) && (ioDataStruct.line2 == true)) {
							stato = 3; 
			}
			else {
				stato = 0;
			}
			ioDataStruct.outp = (ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = false;
			return;
			break;
		case 7:
			if ((ioDataStruct.line1 == true) || (ioDataStruct.line2 == true)) {
							stato = 3; 
			}
			else {
				stato = 0;
			} 
			ioDataStruct.outp = ~(ioDataStruct.line1 ^ ioDataStruct.line2);
			ioDataStruct.overflw = false;
			return;
			break;
		default:
			break;
		}//end switch
	}//end while(true)
}//end process

void b01_UT :: end_of_elaboration()
{
  stato = 0;
}
