//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//-- This confidential and proprietary software may be used only as authorized 
//-- by a licensing agreement from ESD University of Verona - EDALab s.r.l.                      
//--
//--
//-- Title:             Multimedia System Design Developement
//-- Project:           V-CLIP 1.0
//--
//-- 
//-- File:              b01_RTL.cpp
//-- Author:            Nicola Bombieri
//-- Date:              24 December 2005 
//-- Description:       RTL b01 module
//-- 
//-- Mod History: $Log: $
//                                                                            
//----------------------------------------------------------------------------
//-- RCS Version:  $Id: $                                           
//----------------------------------------------------------------------------

// Modified by Nannan He

#include <systemc.h>

SC_MODULE(b01_RTL) 
{
	public:
		sc_in   <bool > clock;
		sc_in   <bool > reset;
		sc_in   <bool > line1;
		sc_in   <bool > line2; 
		
		sc_out  <bool > outp;
		sc_out  <bool > overflw;
		
		void process();
		sc_uint<3> stato;
		
		SC_CTOR(b01_RTL)
		{
			SC_METHOD(process);
			sensitive_pos << clock << reset;
		}
		
		~b01_RTL()
		{  }
};

int tmp;

void b01_RTL::process()
{
  tmp = stato;

  if (reset.read() == true) 
	{
    stato = sc_uint<3>(0); 
    outp.write(false); 
    overflw.write(false); 
  }
  else if (clock.read() == 1) 
	{
    if (stato == sc_uint<3>(0)) 
		{
      if ((line1.read() == true) && (line2.read() == true))
			{
        stato = sc_uint<3>(4); 
      }
      else
			{
        stato = sc_uint<3>(1); 
      }
      outp.write(line1.read() ^ line2.read()); 
      overflw.write(false); 
    }
    else if (stato == sc_uint<3>(3)) 
		{
      if ((line1.read() == true) && (line2.read() == true)) 
			{
        stato = sc_uint<3>(4); 
      }
      else 
			{
        stato = sc_uint<3>(1); 
      }
      outp.write(line1.read() ^ line2.read()); 
      overflw.write(true); 
    }
    else if (stato == sc_uint<3>(1)) 
		{
      if ((line1.read() == true) && (line2.read() == true)) 
			{
        stato = sc_uint<3>(5); 
      }
      else 
			{
        stato = sc_uint<3>(2); 
      }
      outp.write(line1.read() ^ line2.read()); 
      overflw.write(false); 
    }
    else if (stato == sc_uint<3>(4)) 
		{
      if ((line1.read() == true) || (line2.read() == true)) 
			{
        stato = sc_uint<3>(5); 
      }
      else 
			{
        stato = sc_uint<3>(2); 
      }
      outp.write(~(line1.read() ^ line2.read())); 
      overflw.write(false); 
    }
    else if (stato == sc_uint<3>(2)) 
		{
      if ((line1.read() == true) && (line2.read() == true)) 
			{
        stato = sc_uint<3>(7); 
      }
      else 
			{
        stato = sc_uint<3>(6); 
      }
      outp.write(line1.read() ^ line2.read()); 
      overflw.write(false); 
    }
    else if (stato == sc_uint<3>(5)) 
		{
      if ((line1.read() == true) || (line2.read() == true)) 
			{
        stato = sc_uint<3>(7); 
      }
      else 
			{
        stato = sc_uint<3>(6); 
      }
      outp.write(~(line1.read() ^ line2.read())); 
      overflw.write(false); 
    }
    else if (stato == sc_uint<3>(6)) 
		{
      if ((line1.read() == true) && (line2.read() == true)) 
			{
        stato = sc_uint<3>(3); 

      }
      else 
			{
        stato = sc_uint<3>(0); 
      }
      outp.write(line1.read() ^ line2.read()); 
      overflw.write(false); 

    }
    else if (stato == sc_uint<3>(7)) 
		{
      if ((line1.read() == true) || (line2.read() == true)) 
			{
        stato = sc_uint<3>(3); 
      }
      else 
			{
        stato = sc_uint<3>(0); 
      }
      outp.write(~(line1.read() ^ line2.read())); 
      overflw.write(false); 
    }
    else
		{   }

  }
  else 
	{  }
}

