#include <iostream>

SC_MODULE(bcd_to_binary_H)
{
	sc_uint<5>	dat_bcd_i;
	sc_uint<5>	dat_bin_o;
	sc_uint<5>	dat_gray_o;
	
	void convert_code();
	void convert_code_gray();
	void run();
	
	sc_uint<4>	msb;
	sc_uint<4>	ls_byte;
	
	SC_CTOR(bcd_to_binary_H)
	{
		SC_THREAD(run);
	}
};

void bcd_to_binary_H::convert_code()
{
  msb = dat_bcd_i[4];
  ls_byte = dat_bcd_i.range(3,0);
  dat_bin_o = (msb*10) + ls_byte;
}

void bcd_to_binary_H::convert_code_gray()
{
  dat_gray_o[3] = dat_bin_o[3];
  dat_gray_o[2] = dat_bin_o[3] ^ dat_bin_o[2];
  dat_gray_o[1] = dat_bin_o[2] ^ dat_bin_o[1];
  dat_gray_o[0] = dat_bin_o[1] ^ dat_bin_o[0];
}

void bcd_to_binary_H::run()
{
  while(true)
  {
    convert_code();
    convert_code_gray();
  }
}

