#include <iostream>
#include "bcd_to_binary_H.h"

//--------------------------------
#define MAX_ROW	100
#define MAX_COL	100
#define NUM_IN	1
#define NUM_OUT 2

ifstream fin;
unsigned int test_data_in[MAX_ROW][MAX_COL];
unsigned int test_data_out[MAX_ROW][MAX_COL];
unsigned short test_data_out_x[MAX_ROW][MAX_COL];

std::string Trim(const std::string &s) {
	std::string::size_type a = s.find_first_not_of(" ");
	return s.substr(a);
}

void read_test_input()
{
	std::string fname = "test_input.txt";
	std::string line;
	std::string subline;
	int c, c1;
	
	// initialize test data
	for(int i = 0; i < MAX_ROW; i++)
		for(int j = 0; j < MAX_COL; j++)
		{
			test_data_in[i][j] = 0;
			test_data_out[i][j] = 0;
			test_data_out_x[i][j] = 0;
		}
		
		// read in test data
	fin.open(fname.c_str());	
	assert(fin.is_open());
	
	getline(fin, line);
	c = 0;
	c1 = 0;
	while(true)
	{
		getline(fin, line);
		if(line.size() == 0)	break;
		
		if(line.find("i_x") != std::string::npos)
		{
			line = line.substr(line.find("i") + 3);
			for(int i = 0; i < NUM_IN; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				assert(subline != "x");
				test_data_in[c][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "i-" << test_data_in[c][i] << " ";
			}
			c++;
			// 			std::cout << std::endl;
		}
		else if(line.find("o_x") != std::string::npos)
		{
			line = line.substr(line.find("o") + 3);
			for(int i = 0; i < NUM_OUT; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				if(subline == "x")
				{
					test_data_out_x[c1][i] = 1;
				}
				else
					test_data_out[c1][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "o-" << test_data_out[c1][i] << test_data_out_x[c1][i];
			}
			c1++;
			// 			std::cout << std::endl;
		}
		else
		{
			//	std::cout << "else: " << line << std::endl;
			//	assert(0);
		}
	}
}
//--------------------------------

void bcd_to_binary_H::convert_code()
{
  msb = dat_bcd_i[4];
  ls_byte = dat_bcd_i.range(3,0);
  dat_bin_o = (msb*10) + ls_byte;
}

void bcd_to_binary_H::convert_code_gray()
{
  dat_gray_o[3] = dat_bin_o[3];
  dat_gray_o[2] = dat_bin_o[3] ^ dat_bin_o[2];
  dat_gray_o[1] = dat_bin_o[2] ^ dat_bin_o[1];
  dat_gray_o[0] = dat_bin_o[1] ^ dat_bin_o[0];
}

void bcd_to_binary_H::run()
{
	//---------------------------
	read_test_input();
	int c = 0;
	//----------------------------
  while(true)
  {
	//---------------------------
		dat_bcd_i = test_data_in[c][0];
		std::cout << "i-" << dat_bcd_i << std::endl;
	//---------------------------

    convert_code();
    convert_code_gray();
		
	//---------------------------
		std::cout << "o-" << dat_bin_o << " " << dat_gray_o << std::endl;		
		//if(test_data_out_x[c][0] == 0)
		if(c < 9)
			assert((unsigned)(dat_bin_o) == test_data_out[c+1][0]);
		//if(test_data_out_x[c][1] == 0)
		if(c < 8)
			assert((unsigned)(dat_gray_o) == test_data_out[c+2][1]);
		
		c++;
		if(c >= 10)
			break;
	//-------------------------
  }
}

