#include "systemc.h"

SC_MODULE(bcd_to_binary_L)
{
  sc_in<bool>	clk_i;
  sc_in<sc_uint<5> >	dat_bcd_i;

  sc_out<sc_uint<4> >	dat_bin_o;
  sc_out<sc_uint<4> >	dat_gray_o;

  void convert_code_1();
  void convert_code_2();
  void convert_code_gray();

  sc_signal<sc_uint<4> > tens_digit;
  sc_signal<sc_uint<4> > no_tens_digit;
  sc_signal<bool> tens_select;
  
	SC_CTOR(bcd_to_binary_L)
  {
    SC_METHOD(convert_code_1);
    sensitive << clk_i.pos();

    SC_METHOD(convert_code_2);
    sensitive << clk_i.pos();

    SC_METHOD(convert_code_gray);
    sensitive << clk_i.pos();
  }
};
