#include "systemc.h"

SC_MODULE(byte_mixcolum_L)
{
  sc_in<sc_uint<8> > a, b, c, d;
  sc_out<sc_uint<8> > outx, outy;

  void dataflow();
  sc_uint <8> xtime(sc_uint<8> in);

  SC_CTOR(byte_mixcolum_L)
  {
    SC_METHOD(dataflow);
    sensitive << a << b << c << d;
  }
};

//Aux function
sc_uint <8> byte_mixcolum_L::xtime(sc_uint<8> in)
{
  sc_uint<4> xtime_t;
  sc_uint<8> out;

  out.range(7, 5) = in.range(6, 4);
  xtime_t[3] = in[7]; 
  xtime_t[2] = in[7]; 
  xtime_t[1] = 0; 
  xtime_t[0] = in[7];
  out.range(4, 1) = xtime_t ^ in.range(3, 0);
  out[0] = in[7];

  return out;
}

void byte_mixcolum_L::dataflow()
{
  sc_uint<8> w1, w2, w3, w4, w5, w6, w7, w8, outx_var;

  w1 = a.read() ^ b.read();
  w2 = a.read() ^ c.read();
  w3 = c.read() ^ d.read();

  w4 = xtime(w1);
  w5 = xtime(w3);

  w6 = w2 ^ w4 ^ w5;

  w7 = xtime(w6);
  w8 = xtime(w7);

  outx_var = b.read() ^ w3 ^ w4;
  outx.write(outx_var);
  outy.write(w8 ^ outx_var);
}



