//////////////////////////////////////////////////////////////////////
////                                                              ////
////  Mixcolumns for 8 bit                                        ////
////                                                              ////
////  This file is part of the SystemC AES                        ////
////                                                              ////
////  Description:                                                ////
////  Mixcolum for a byte                                         ////
////                                                              ////
////  Generated automatically using SystemC to Verilog translator ////
////                                                              ////
////  To Do:                                                      ////
////   - done                                                     ////
////                                                              ////
////  Author(s):                                                  ////
////      - Javier Castillo, jcastilo@opencores.org               ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
////                                                              ////
//// Copyright (C) 2000 Authors and OPENCORES.ORG                 ////
////                                                              ////
//// This source file may be used and distributed without         ////
//// restriction provided that this copyright statement is not    ////
//// removed from the file and that any derivative work contains  ////
//// the original copyright notice and the associated disclaimer. ////
////                                                              ////
//// This source file is free software; you can redistribute it   ////
//// and/or modify it under the terms of the GNU Lesser General   ////
//// Public License as published by the Free Software Foundation; ////
//// either version 2.1 of the License, or (at your option) any   ////
//// later version.                                               ////
////                                                              ////
//// This source is distributed in the hope that it will be       ////
//// useful, but WITHOUT ANY WARRANTY; without even the implied   ////
//// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      ////
//// PURPOSE.  See the GNU Lesser General Public License for more ////
//// details.                                                     ////
////                                                              ////
//// You should have received a copy of the GNU Lesser General    ////
//// Public License along with this source; if not, download it   ////
//// from http://www.opencores.org/lgpl.shtml                     ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
//
// CVS Revision History
//
// $Log: not supported by cvs2svn $
// Revision 1.3  2004/08/30 16:23:57  jcastillo
// Indentation corrected
//
// Revision 1.2  2004/07/22 08:51:22  jcastillo
// Added timescale directive
//
// Revision 1.1.1.1  2004/07/05 09:46:23  jcastillo
// First import
//

`include "byte_mixcolum.v"

module top();

reg [7:0] a,b,c,d;

wire [7:0] outx, outy;
reg clk;

always begin
	#5
	clk = ~clk;
end

initial begin
	$dumpfile("byte_mixcolum.vcd");
  $dumpvars();

	clk <= 0;

	repeat(10) begin
		@ (posedge clk);
		a = $random % 256;
		b = $random % 256;
		c = $random % 256;
		d = $random % 256;

		$display("%d\ti_x%d:%d:%d:%d:", 
			$time, 
			a, b, c, d
		);
		#2
		$display("%d\to_x%d:%d:", 
			$time, 
			outx, outy
		);
	end
	$finish;
end

// Connect the DUT
byte_mixcolum U(
  a, 
	b, 
	c,
	d,
	outx,
	outy
);

endmodule
