#include "systemc.h"

// BINARY ENCODED state machine: drctCntl
// State codes definitions:
#define START_DC 0
#define CHK_DRCT_CNTL 1
#define DRCT_CNTL_WAIT_GNT 2
#define DRCT_CNTL_CHK_LOOP 3
#define DRCT_CNTL_WAIT_RDY 4
#define IDLE_FIN 5
#define IDLE_WAIT_GNT 6
#define IDLE_WAIT_RDY 7

#define TX_DIRECT_CONTROL 0
#define TX_IDLE 5

SC_MODULE(directControl_L)
{
  sc_in<bool>		HCTxPortGnt;
  sc_in<bool>		HCTxPortRdy;
  sc_in<bool>		clk;
  sc_in<bool>		directControlEn;
  sc_in<sc_uint<2> >	directControlLineState;
  sc_in<bool>		rst;

  sc_out<sc_uint<8> >	HCTxPortCntl;
  sc_out<sc_uint<8> >	HCTxPortData;
  sc_out<bool>		HCTxPortReq;
  sc_out<bool>		HCTxPortWEn;

  void drctCntl_NextState();
  void drctCntl_CurrentState();
  void drctCntl_RegOutput();
	void show();

  sc_signal<sc_uint<8> >	next_HCTxPortCntl;
  sc_signal<sc_uint<8> >	next_HCTxPortData;
  sc_signal<bool>		next_HCTxPortReq;
  sc_signal<bool>		next_HCTxPortWEn;

  sc_signal<sc_uint<4> >	CurrState_drctCntl;
  sc_signal<sc_uint<4> >	NextState_drctCntl;
	
  SC_CTOR(directControl_L)
  {
    SC_METHOD(drctCntl_NextState);
     sensitive << directControlLineState << directControlEn 
 			<< HCTxPortGnt << HCTxPortRdy << HCTxPortReq 
 			<< HCTxPortWEn << HCTxPortData << HCTxPortCntl << CurrState_drctCntl;

    SC_METHOD(drctCntl_CurrentState);
    sensitive << clk.pos();

    SC_METHOD(drctCntl_RegOutput);
    sensitive << clk.pos();		

		SC_METHOD(show);
		sensitive << clk.neg();
  }
};
