`include "directcontrol.v"

module top ();

reg   HCTxPortGnt;
reg   HCTxPortRdy;
reg   clk;
reg   directControlEn;
reg   [1:0] directControlLineState;
reg   rst;

wire  [7:0] HCTxPortCntl;
wire  [7:0] HCTxPortData;
wire  HCTxPortReq;
wire  HCTxPortWEn;

reg rst_tmp;

// Clock generator
always
begin
  #5
  clk = ~clk;
end

initial begin
  $dumpfile ("directcontrol.vcd");
  $dumpvars();
  rst <= 1'b1;
  clk <= 1'b0;
	rst_tmp <= 1'b0;

	repeat(10) begin
		@ (posedge clk);

		if(rst_tmp == 1'b1)
		begin
			rst = 1'b0;
		end

		if(rst_tmp == 1'b0)
		begin
			rst_tmp = 1'b1;
		end

		HCTxPortGnt = ($random > 0) ? 1'b1 : 1'b0;
		HCTxPortRdy = ($random > 0) ? 1'b1 : 1'b0;
		directControlEn = ($random > 0) ? 1'b1 : 1'b0;
		directControlLineState = $random % 4;

		$display("%d\ti_x%b:%b:%b:%d:%b:", 
			$time, 
			HCTxPortGnt,
			HCTxPortRdy,
			directControlEn,
			directControlLineState,
			rst
		);
		#2
		$display("%d\to_x%d:%d:%b:%b:", 
			$time, 
			HCTxPortCntl,
			HCTxPortData,
			HCTxPortReq,
			HCTxPortWEn,
		);
	end
	$finish;
end 

// Connect the DUT
directControl U (
	HCTxPortCntl,
	HCTxPortData,
	HCTxPortGnt,    
	HCTxPortRdy,
	HCTxPortReq,
	HCTxPortWEn,
	clk,
	directControlEn,
	directControlLineState,
	rst
);

endmodule
