#include "systemc.h"

// Most significant nibble corresponds to major revision.
// Least significant nibble corresponds to minor revision.
#define USBHOSTSLAVE_VERSION_NUM 0x20   

//Host slave common registers
#define HOST_SLAVE_CONTROL_REG 0
#define HOST_SLAVE_VERSION_REG 1

SC_MODULE(hostSlaveMuxBI_H)
{
  sc_uint<8> dataIn;
  bool address;
  bool writeEn;
  bool strobe_i;
  bool hostSlaveMuxSel;
  bool rstFromWire;

  sc_uint<8> dataOut;
  bool hostMode;
  bool rstSyncToBusClkOut;
  bool rstSyncToUsbClkOut;

  void sync_write_demux();
  void async_read_mux(bool);
  void reset_control();
  void rst_shift();
  void double_sync();
  void run();

  //internal wire and regs
  sc_uint<6> rstShift;
  bool rstFromBus;
  bool rstSyncToUsbClkFirst;
	
  SC_CTOR(hostSlaveMuxBI_H)
  {
    SC_THREAD(run);
  }
};
