#include <iostream>
#include "hostSlaveMuxBI_L.h"

//sync write demux
void hostSlaveMuxBI_L::sync_write_demux()
{
  if (rstSyncToBusClkOut.read() == true)
  {
    hostMode.write(false);
  }
  else 
  {
    if (writeEn.read() == true && hostSlaveMuxSel.read() == true && 
      strobe_i.read() == true && address.read() == HOST_SLAVE_CONTROL_REG)
    {
      hostMode.write(dataIn.read()[0]);
    }
    
    if (writeEn.read() == true && hostSlaveMuxSel.read() == true && 
      strobe_i.read() == true && address.read() == HOST_SLAVE_CONTROL_REG && (dataIn.read()[1]) == true)
    {
      rstFromBus.write(true);
    }
    else
    {
      rstFromBus.write(false);
    }
  }
}

// async read mux
void hostSlaveMuxBI_L::async_read_mux()
{
  switch(address.read())
  {
    case HOST_SLAVE_CONTROL_REG:
      dataOut.write(0x00 | hostMode.read());
      break;
    case HOST_SLAVE_VERSION_REG:
      dataOut.write(USBHOSTSLAVE_VERSION_NUM);
      break;
  }
}

// reset control
//generate 'rstSyncToBusClk'
//assuming that 'busClk' < 5 * 'usbClk'. ie 'busClk' < 240MHz
void hostSlaveMuxBI_L::reset_control()
{
  if ((rstFromWire.read() == true) || (rstFromBus.read() == true))
  {
    rstShift.write(0x3F);
  }
  else
  {
    rstShift.write(0x00 | (rstShift.read()).range(5, 1));
  }
}

void hostSlaveMuxBI_L::rst_shift()
{
  rstSyncToBusClkOut.write(rstShift.read()[0]);
}

// double sync across clock domains to generate 'forceEmptySyncToWrClk'
void hostSlaveMuxBI_L::double_sync()
{
  rstSyncToUsbClkFirst.write(rstSyncToBusClkOut.read());
  rstSyncToUsbClkOut.write(rstSyncToUsbClkFirst.read());
}

