`include "hostSlaveMuxBI.v"

module top ();

reg [7:0] dataIn;
reg address;
reg writeEn;
reg strobe_i;
reg busClk;
reg usbClk;
wire [7:0] dataOut;
reg hostSlaveMuxSel;
wire hostMode;
reg rstFromWire;
wire rstSyncToBusClkOut;
wire rstSyncToUsbClkOut;


// Clock generator
always begin
  #5 
  usbClk = ~usbClk;
  busClk = ~busClk;
end

initial begin
  $dumpfile ("hostSlaveMuxBI.vcd");
  $dumpvars();

  dataIn <= 7;
  address <= 0;
  writeEn <= 0;
  strobe_i <= 0;
  busClk <= 0;
  usbClk <= 1;
  hostSlaveMuxSel <= 0;
  rstFromWire <= 0;

  #10
  address <= 1;
  writeEn <= 1;
  strobe_i <= 1;
  hostSlaveMuxSel <= 1;
  rstFromWire <= 1;

  #10
  address <= 0;
  writeEn <= 0;

  #10
  strobe_i <= 0;

  #10
  hostSlaveMuxSel <= 0;
  rstFromWire <= 0;

  #10
  writeEn <= 1;

  #10
  address <= 1;

  #10
  hostSlaveMuxSel <= 1;

  #20 $finish;
end 

// Connect the DUT
hostSlaveMuxBI U (
  dataIn, dataOut, address, writeEn, strobe_i, busClk, usbClk,
  hostMode, hostSlaveMuxSel, rstFromWire, rstSyncToBusClkOut, rstSyncToUsbClkOut
);

always @ (posedge usbClk or posedge busClk)
begin 
  $display ("%d %d %b %b %b %b %b %b %b \t %d %b %b %b", $time, 
    dataIn, address, writeEn, strobe_i, busClk, usbClk, hostSlaveMuxSel, rstFromWire, 
    dataOut, hostMode,  rstSyncToBusClkOut, rstSyncToUsbClkOut);
end

endmodule
