`include "key_gen.v"

module top ();
//------------------------
reg [55:0] previous_key;
reg [3:0] iteration;
reg decrypt;

wire [55:0] non_perm_key;
wire [47:0] new_key;
//--------------------

reg clk;
reg [55:0] previous_key_tmp;
reg [3:0] iteration_tmp;

// Clock generator
always begin
  #5 
  clk = ~clk;
end

initial begin
  $dumpfile("key_gen.vcd");
  $dumpvars();

	clk <= 0;

	repeat(10) begin
		@ (posedge clk);
		previous_key_tmp = $random;
		if(previous_key == previous_key_tmp)
		begin
			previous_key = $random;
		end
		else			
			previous_key = previous_key_tmp;

		iteration_tmp = $random % 16;
		if(iteration == iteration_tmp)
		begin
			iteration = $random % 16;
		end
		else
			iteration = iteration_tmp;

		decrypt = ($random > 0) ? 1'b1 : 1'b0;

		$display("%d\ti_x%d:%d:%d:%d:%d:%b:", 
			$time, 
			previous_key[55:48],
			previous_key[47:32],
			previous_key[31:16],
			previous_key[15:0],
			iteration,
			decrypt,
		);
		#2
		$display("%d\to_x%d:%d:%d:%d:%d:%d:%d:", 
			$time, 
			non_perm_key[55:48],
			non_perm_key[47:32],
			non_perm_key[31:16],
			non_perm_key[15:0],
			new_key[47:32],
			new_key[31:16],
			new_key[15:0],		
		);
	end
	$finish;
end 

// Connect the DUT
key_gen U(
  previous_key, 
	iteration, 
	decrypt,
	non_perm_key,
	new_key
);

endmodule
