
module bios(cs, addr, CLK, bios_valid, dataout);
input cs;
input [31:0] addr;
input CLK;

output bios_valid;
output [31:0] dataout;

`define BOOT_LENGTH 6

reg [31:0] imemory[0:`BOOT_LENGTH];
reg [31:0] wait_cycles;
reg [31:0] address;
reg bios_valid;
reg [31:0] dataout;

always @ (posedge CLK)
begin
	wait(cs == 0)
	begin
		address = addr;
		if (address < `BOOT_LENGTH)
		begin
			#2 dataout = imemory[address];
			#1 bios_valid = 1;
			#1 bios_valid = 0;
		end
		else
		begin
			#1 bios_valid = 0;
		end
	end
end
endmodule

// module main(main_d, cs, addr, CLK);
// input main_d;
// 
// output cs;
// output [31:0] addr;
// output CLK;
// 
// reg cs;
// reg [31:0] addr;
// reg CLK;
// wire bios_valid;
// wire [31:0] dataout;
// 
// bios ins (.cs(cs), .addr(addr), .CLK(CLK), .bios_valid(bios_valid), .dataout(dataout));
// 
// endmodule