/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************
 
  bios.cpp -- System Bios.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.
 
      Name, Affiliation, Date: Nicolas Blanc, ETHZ, 2009
  Description of Modification: major revision

      Name, Affiliation, Date:
  Description of Modification:
 
 *****************************************************************************/

#include "systemc.h"

#define BOOT_LENGTH  6

SC_MODULE(bios_H)
{ 
	bool 				cs;    		// chip select
	sc_uint<32> addr;  		// physical address
	bool 				bios_valid; 	// out valid
	sc_uint<32> dataout; 	// instruction out

  // Parameter
  static sc_uint<32>  imemory[BOOT_LENGTH];	 			// BIOS program data memory

  //Constructor 
  SC_CTOR(bios_H) {
    SC_THREAD(run);
  }

  // Process functionality in member function below
  void run();
};

