/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************
 
  bios.cpp -- System Bios.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.
 
      Name, Affiliation, Date: Nicolas Blanc, ETHZ, 2009
  Description of Modification: major revision

      Name, Affiliation, Date:
  Description of Modification:
 
 *****************************************************************************/

#include "systemc.h"
#include "bios_L.h"

sc_uint<32> bios_l::imemory[BOOT_LENGTH] = 
{
0x0f000000,
0x0f000001, 
0x0f000002, 
0x0f000003, 
0x0f000004, 
0x0f000005
};

void bios_l::entry()
{
 sc_uint<32> address;

 while (true)
 {
		do { wait(); } while ( !(cs == true) ); 
    address = addr.read();

		if (address < BOOT_LENGTH)
		{		// in BOOTING STAGE    
			// Introduce delay needed
			wait();
			wait();

			dataout.write(imemory[address]);
			bios_valid.write(true);
			wait();
			bios_valid.write(false);
			wait();   
		}
		else
		{
			bios_valid.write(false);
			wait();
		}
		
		std::cout << sc_time_stamp() << "**o- " << addr.read() << ":" 
			<< bios_valid.read() << " "
			<< dataout.read() << std::endl;
	}
} // end of entry function

