
module bios(cs, addr, CLK, bios_valid, dataout);
input cs;
input [31:0] addr;
input CLK;

output bios_valid;
output [31:0] dataout;

`define BOOT_LENGTH 6

reg [31:0] imemory[0:`BOOT_LENGTH];
reg [31:0] wait_cycles;
reg [31:0] address;
reg bios_valid;
reg [31:0] dataout;

initial
begin
	imemory[0] = 32'hf0000000;
	imemory[1] = 32'hf0000001;
	imemory[2] = 32'hf0000002;
	imemory[3] = 32'hf0000003;
	imemory[4] = 32'hf0000004;
	imemory[5] = 32'hf0000005;
end

always @ (posedge CLK)
begin
	wait(cs == 0)
	begin
		address = addr;
		if (address < `BOOT_LENGTH)
		begin
			#2 dataout = imemory[address];
			#1 bios_valid = 1;
			#1 bios_valid = 0;
		end
		else
		begin
			#1 bios_valid = 0;
		end
	end
end
endmodule
