`include "bios.v"

module top();

reg cs;
reg [31:0] addr;
reg CLK;

wire bios_valid;
wire [31:0] dataout;

// Clock generator
always
begin
  #5
  CLK = ~CLK;
end

initial begin
  $dumpfile ("bios.vcd");
  $dumpvars();
  CLK <= 1'b0;

	repeat(10) begin
		@ (posedge CLK);

		cs = ($random > 0) ? 1'b1 : 1'b0;
		addr = $random;

		$display("%d\ti_x%b:%d:", 
			$time, 
			cs,
			addr,
		);
		#5
		$display("%d\to_x%b:%d:", 
			$time, 
			bios_valid,
			dataout
		);
	end
	$finish;
end 

// Connect the DUT
bios U (
	cs,
	addr,
	CLK,
	bios_valid,
	dataout
);
endmodule
