/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************
 
  control.cpp  -- Instruction Decode Unit.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.
 
      Name, Affiliation, Date: Nicolas Blanc, ETHZ, 2009
  Description of Modification: many code updates

      Name, Affiliation, Date:
  Description of Modification:
 
 *****************************************************************************/
 

#include "systemc.h"

SC_MODULE(control_H) 
{ 
	bool  		      resetin;      		// input reset
	sc_uint<32>  		instruction;		// fetched instruction
	bool  		      instruction_valid;// input valid
	bool  		      alu_valid;      	// ALU data valid
	sc_int<32>  		alu_dout; 		  // data from ALU     
	sc_int<32>  		dram_dout;     // data from Dcache
	bool  		      dram_rd_valid;    // Dcache read data valid
	bool  		      dram_wr_ack;      // Dcache write ack
	sc_int<32>  		fpu_dout;      		// data from FPU
	bool  		      fpu_valid;      	// FPU data valid
	sc_int<32>   		mmx_dout;      		// data from FPU
	bool 			      mmx_valid;      	// data valid from MMX
	bool 			      clear_branch;      	// clear outstanding branch
	bool 			      display_done;      	// display to monitor done
	sc_uint<32> 		pc;      		// program counter from IFU
	sc_int<32>		 	rfu_data1;       // RFU data1
	sc_int<32> 			rfu_data2;       // RFU data2

	bool 	    			next_pc;      		// next pc ++ ?
	bool  			    branch_valid;      	// branch valid signal
	sc_uint<32>  		branch_target_address;	// branch target address
	bool	 			    dram_cs;      	// memory access valid 
	sc_uint<32>	  	dram_addr;      	// memory physical address
	sc_int<32>   		dram_datain;      	// memory datain
	sc_uint<8>   		alu_op;      		// ALU/FPU/MMU Opcode
	bool  			    dram_we;      	  // memory write enable
	sc_int<32>      src_A;			// operand A
	sc_int<32>      src_B;			// operand B
	bool  			    alu_cs;      	// enable ALU
	bool  			    fpu_cs;      	// enable FPU
	bool  			    mmx_cs;      	  // enable MMU
	bool  			    pid_valid;      	  // load process ID
	sc_int<32>   		pid_data;       // process ID value
	bool 						rfu_rst;
	bool						rfu_cs;
	bool						rfu_re;
	bool						rfu_we;
	sc_uint<4>  		rfu_addr1;    // RFU addr1
	sc_uint<4> 		 	rfu_addr2;    // RFU addr2
	sc_uint<4> 			rfu_addr3;    // RFU addr3
	sc_int<32>  		rfu_data3;    // RFU data3

  // Process functionality in member function below
  void run_control();
	void run();
	
  //Constructor 
  SC_CTOR(control_H) {
    SC_THREAD(run);
  }
};


