`include "fetch.v"

module top();

reg	[31:0] ramdata;
reg	[31:0] branch_address;
reg	 next_pc;
reg	 branch_valid;
reg	 interrupt;
reg	[31:0] int_vectno;
reg ram_valid;
reg CLK;

wire ram_cs;
wire [31:0] address;
wire [31:0] instruction;
wire instruction_valid;
wire [31:0] program_counter;
wire interrupt_ack;
wire branch_clear;
wire reset;

// Clock generator
always
begin
  #5
  CLK = ~CLK;
end

initial
begin
  $dumpfile ("directcontrol.vcd");
  $dumpvars();
  CLK <= 1'b0;

	repeat(10) begin
		@ (posedge CLK);

		ramdata = $random;
		branch_address = $random;
		next_pc = ($random > 0) ? 1'b1 : 1'b0;
		branch_valid = ($random > 0) ? 1'b1 : 1'b0;
		interrupt = ($random > 0) ? 1'b1 : 1'b0;
		int_vectno = $random;
		ram_valid = ($random > 0) ? 1'b1 : 1'b0;

		$display("%d\ti_x%d:%d:%b:%b:%b:%d:%b:", 
			$time, 
			ramdata,
			branch_address,
			next_pc,
			branch_valid,
			interrupt,
			int_vectno,
			ram_valid,
		);
		#2
		$display("%d\to_x%b:%d:%d:%b:%d:%b:%b:%b:", 
			$time, 
			ram_cs,
			address,
			instruction,
			instruction_valid,
			program_counter,
			interrupt_ack,
			branch_clear,
			reset
		);
	end
	$finish;
end

// Connect the DUT
fetch U (
	ramdata,
	branch_address,
	next_pc,    
	branch_valid,
	interrupt,
	int_vectno,
	ram_valid,
	CLK,
	ram_cs,
	address,
	instruction,
	instruction_valid,
	program_counter,
	interrupt_ack,
	branch_clear,
	reset
);

endmodule
