/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************
 
  icache.cpp -- Instruction Cache Unit.
 
  Original Author: Martin Wang, Synopsys, Inc.
 
 *****************************************************************************/
 
/*****************************************************************************
 
  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.
 
      Name, Affiliation, Date: Gene Bushuyev, Synopsys, Inc.
  Description of Modification: - bug - read/write outside of allocated memory
 
      Name, Affiliation, Date: Nicolas Blanc, ETHZ, 2009
  Description of Modification: many code updates

 *****************************************************************************/


#include "systemc.h"
#include <iostream>

#define BOOT_LENGTH 6
#define MAX_CODE_LENGTH 164

SC_MODULE(icache_H)
{ 
	bool  		      cs; 	        // chip select
	sc_uint<32>   	addr;  	      // address
	bool  		      ld_valid;	    // load valid    
	sc_int<32>   		ld_data;      // load data value
	sc_uint<32> 	  dataout;  	  // ram data out
	bool  		    	icache_valid; // output valid

  // Parameter
  static sc_uint<32> icmemory[MAX_CODE_LENGTH];	 // icache data memory
  sc_uint<32> pid;	 				// process ID

  // Process functionality in member function below
  void run();
 
  //Constructor
  SC_CTOR(icache_H) {
		SC_THREAD(run);
  }
};


