`include "mmxu.v"

module top();

reg cs;
reg [7:0] opcode;
reg [31:0] dina;
reg [31:0] dinb;
reg CLK;

wire [31:0] dout;
wire out_valid;

// Clock generator
always begin
  #5 
  CLK = ~CLK;
end

initial
begin
  $dumpfile("exec.vcd");
  $dumpvars();

	CLK <= 0;

	repeat(10) begin
		@ (posedge CLK);
		
		dina = $random;
		cs = ($random > 0) ? 1'b1 : 1'b0;
		dinb = $random;
		opcode = $random % 256;

		$display("%d\ti_x%b:%d:%d:%d:", 
			$time, 
			cs,
			opcode,
			dina,
			dinb
		);
		#7
		$display("%d\to_x:%d:%b:", 
			$time, 
			dout,
			out_valid
		);
	end
	$finish;
end

mmxu U(
	cs,
	opcode,
	dina,
	dinb,
	dout,
	out_valid,
	CLK
);

endmodule
