`include "pic.v"

module top();

reg ireq0;
reg ireq1;
reg ireq2;
reg ireq3;
reg cs;
reg rd_wr;
reg intack_cpu;

wire intreq;
wire intack;
wire [31:0] vectno;

reg CLK;

// Clock generator
always begin
  #5 
  CLK = ~CLK;
end

initial
begin
  $dumpfile("pic.vcd");
  $dumpvars();

	CLK <= 0;

	repeat(10) begin
		@ (posedge CLK);
		
		ireq0 = ($random > 0) ? 1'b1 : 1'b0;
		ireq1 = ($random > 0) ? 1'b1 : 1'b0;
		ireq2 = ($random > 0) ? 1'b1 : 1'b0;
		ireq3 = ($random > 0) ? 1'b1 : 1'b0;
		cs = ($random > 0) ? 1'b1 : 1'b0;
		rd_wr = ($random > 0) ? 1'b1 : 1'b0;
		intack_cpu = ($random > 0) ? 1'b1 : 1'b0;

		$display("%d\ti_x%b:%b:%b:%b:%b:%b:%b:", 
			$time, 
			ireq0,
			ireq1, 
			ireq2, 
			ireq3, 
			cs, 
			rd_wr, 
			intack_cpu 
		);
		#7
		$display("%d\to_x%b:%b:%d:", 
			$time, 
			intreq,
			intack,
			vectno
		);
	end
	$finish;
end

pic U(
  ireq0, 
	ireq1, 
	ireq2, 
	ireq3, 
	cs, 
	rd_wr, 
	intack_cpu, 
	intreq, 
	intack, 
	vectno
);

endmodule
