module registerfile(clk, rst, cs, re, we, addr1, addr2, addr3, data3, data1, data2);
input clk;
input rst;
input cs;
input re;
input we;
input [3:0] addr1;
input [3:0] addr2;
input [3:0] addr3;
input [31:0] data3;

output [31:0] data1;
output [31:0] data2;

reg [31:0] data1;
reg [31:0] data2;

reg [31:0] reg_tmp[0:15];
reg [4:0] i;

always @(posedge clk)
begin
	if(rst == 1'b1)
		data1 = 0;
	else if((cs == 1'b1) && (re == 1'b1))
		data1 = reg_tmp[addr1];
end

always @(posedge clk)
begin
	if(rst == 1'b1)
		data1 = 0;
	else if((cs == 1'b1) && (re == 1'b1))
		data2 = reg_tmp[addr2];
end

always @(posedge clk)
begin
	if(rst == 1'b1){}
	else if((cs == 1'b1) && (we == 1'b1))
		reg_tmp[addr3] = data3;
end

always @(posedge clk)
begin
	if(rst == 1'b1)
	begin
		for(i = 0; i < 16; i = i+1)
			reg_tmp[i] = 0;
	end
end
endmodule
