#include <iostream>
#include "usbTxWireArbiter_H.h"

//--------------------------------
#define MAX_ROW	100
#define MAX_COL	100
#define NUM_IN	8
#define NUM_OUT 2

ifstream fin;
unsigned int test_data_in[MAX_ROW][MAX_COL];
unsigned int test_data_out[MAX_ROW][MAX_COL];
unsigned short test_data_out_x[MAX_ROW][MAX_COL];

std::string Trim(const std::string &s) {
	std::string::size_type a = s.find_first_not_of(" ");
	return s.substr(a);
}

void read_test_input()
{
	std::string fname = "test_input.txt";
	std::string line;
	std::string subline;
	int c, c1;
	
	// initialize test data
	for(int i = 0; i < MAX_ROW; i++)
		for(int j = 0; j < MAX_COL; j++)
		{
			test_data_in[i][j] = 0;
			test_data_out[i][j] = 0;
			test_data_out_x[i][j] = 0;
		}
		
		// read in test data
	fin.open(fname.c_str());	
	assert(fin.is_open());
	
	getline(fin, line);
	c = 0;
	c1 = 0;
	while(true)
	{
		getline(fin, line);
		if(line.size() == 0)	break;
		
		if(line.find("i_x") != std::string::npos)
		{
			line = line.substr(line.find("i") + 3);
			for(int i = 0; i < NUM_IN; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				assert(subline != "x");
				test_data_in[c][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "i-" << test_data_in[c][i] << " ";
			}
			c++;
			// 			std::cout << std::endl;
		}
		else if(line.find("o_x") != std::string::npos)
		{
			line = line.substr(line.find("o") + 3);
			for(int i = 0; i < NUM_OUT; i++)
			{
				subline = Trim(line.substr(0, line.find(":")));
				line = line.substr(line.find(":") + 1);
				if(subline == "x")
				{
					test_data_out_x[c1][i] = 1;
				}
				else
					test_data_out[c1][i] = (unsigned int)strtoul(subline.c_str(), NULL, 0);
				// 				std::cout << "o-" << test_data_out[c1][i] << test_data_out_x[c1][i];
			}
			c1++;
			// 			std::cout << std::endl;
		}
		else
		{
			//	std::cout << "else: " << line << std::endl;
			//	assert(0);
		}
	}
}
//--------------------------------

// processTxByte/SIETransmitter mux
void USBTxWireArbiter_H::txWireArb_mux()
{
  USBWireRdyOut = USBWireRdyIn;
}

void USBTxWireArbiter_H::txWireArb_arb(unsigned mux)
{
  if (mux == true)
  {
    USBWireWEn = SIETxWEn;
    TxBits = SIETxData;
    TxCtl = SIETxCtrl;
    TxFSRate = SIETxFSRate;
  }
  else
  {
    USBWireWEn = prcTxByteWEn;
    TxBits = prcTxByteData;
    TxCtl = prcTxByteCtrl;
    TxFSRate = prcTxByteFSRate;
  }
}

void USBTxWireArbiter_H::txWireArb(unsigned state)
{
  switch(state)
  {
    case START_TARB:
      state_txWireArb = TARB_WAIT_REQ;
      break;
    case TARB_WAIT_REQ:
      if (prcTxByteReq == true)	
      {
        state_txWireArb = PTXB_ACT;
        prcTxByteGnt = true;
        muxSIENotPTXB = false;
      }
      else if (SIETxReq == true)	
      {
        state_txWireArb = SIE_TX_ACT;
        SIETxGnt = true;
        muxSIENotPTXB = true;
      }
      break;
    case PTXB_ACT:
      if (prcTxByteReq == false)	
      {
        state_txWireArb = TARB_WAIT_REQ;
        prcTxByteGnt = false;
      }
      break;
    case SIE_TX_ACT:
      if (SIETxReq == false)	
      {
        state_txWireArb = TARB_WAIT_REQ;
        SIETxGnt = false;
      }
      break;
  }
}

//--------------------------------------------------------------------
// Machine: txWireArb
//--------------------------------------------------------------------
void USBTxWireArbiter_H::run()
{
  SIETxCtrl = false;
  SIETxData = 10;
  SIETxFSRate = false;
  SIETxReq = false;
  SIETxWEn = true;
  USBWireRdyIn = true;
  prcTxByteCtrl = true;
  prcTxByteData = 9;
  prcTxByteFSRate = false;
  prcTxByteReq = true;
  prcTxByteWEn = false;
  rst = false;

  //--------------------------
  read_test_input();
  int c = 0;	
  //-------------------------

  while(true)
  {
    if (rst)
    {
      state_txWireArb = START_TARB;
      muxSIENotPTXB = 0;
      prcTxByteGnt = 0;
      SIETxGnt = 0;
    }
    else
    {
      txWireArb_mux();
      txWireArb_arb(muxSIENotPTXB);
      txWireArb(state_txWireArb);
    }

   //---------------------
    c++;
    if(c > 9) break;
   //---------------------
  }
}


