#include "systemc.h"
#include <iostream>
#include "usbTxWireArbiter_L.h"


SC_MODULE(testt)
{
  sc_out<bool>	SIETxCtrl;
  sc_out<sc_uint<2> >	SIETxData;
  sc_out<bool>	SIETxFSRate;
  sc_out<bool>	SIETxReq;
  sc_out<bool>	SIETxWEn;

  sc_out<bool>	USBWireRdyIn;

  sc_out<bool>	clk;

  sc_out<bool>	prcTxByteCtrl;
  sc_out<sc_uint<2> >	prcTxByteData;
  sc_out<bool>	prcTxByteFSRate;
  sc_out<bool>	prcTxByteReq;
  sc_out<bool>	prcTxByteWEn;

  sc_out<bool>	rst;

  void stimuli()
	{
		rst.write(true);

		SIETxData.write(1);
		prcTxByteData.write(2);

		SIETxCtrl.write(false);
		SIETxFSRate.write(false);
		SIETxReq.write(false);
		SIETxWEn.write(false);

		prcTxByteCtrl.write(false);
		prcTxByteFSRate.write(false);
		prcTxByteReq.write(false);
		prcTxByteWEn.write(false);


		wait(10, SC_NS); 
		rst.write(false);
		
		wait(10, SC_NS); 
		SIETxCtrl.write(true);
		SIETxFSRate.write(true);
		SIETxReq.write(true);
		SIETxWEn.write(true);

		wait(10, SC_NS); 
		prcTxByteCtrl.write(true);
		prcTxByteFSRate.write(true);
		prcTxByteReq.write(true);
		prcTxByteWEn.write(true);
		
		wait(10, SC_NS); 
		SIETxCtrl.write(false);
		SIETxFSRate.write(false);
		SIETxReq.write(false);
		SIETxWEn.write(false);
		
		wait(10, SC_NS); 
		SIETxCtrl.write(false);
		SIETxFSRate.write(true);
		SIETxReq.write(false);
		SIETxWEn.write(true);
		
		wait(10, SC_NS); 
		prcTxByteCtrl.write(true);
		prcTxByteFSRate.write(false);
		prcTxByteReq.write(true);
		prcTxByteWEn.write(false);	
		
		wait(20, SC_NS); 
		sc_stop();
	}
	
  void clk_gen()
	{
		while(true) 
		{
			clk.write(false);
			wait(5, SC_NS);
			clk.write(true);
			wait(5, SC_NS);
		}
	}

  SC_CTOR(testt) 
  {
    SC_THREAD(stimuli);
    SC_THREAD(clk_gen);
  }
};

SC_MODULE(monitor)
{
  sc_in<bool>	SIETxCtrl;
  sc_in<sc_uint<2> >	SIETxData;
  sc_in<bool>	SIETxFSRate;
  sc_in<bool>	SIETxReq;
  sc_in<bool>	SIETxWEn;
  sc_in<bool>	USBWireRdyIn;
  sc_in<bool>	clk;
  sc_in<bool>	prcTxByteCtrl;
  sc_in<sc_uint<2> >	prcTxByteData;
  sc_in<bool>	prcTxByteFSRate;
  sc_in<bool>	prcTxByteReq;
  sc_in<bool>	prcTxByteWEn;
  sc_in<bool>	rst;

  sc_in<bool>	SIETxGnt;
  sc_in<sc_uint<2> >	TxBits;
  sc_in<bool>	TxCtl;
  sc_in<bool>	TxFSRate;
  sc_in<bool>	USBWireRdyOut;
  sc_in<bool>	USBWireWEn;
  sc_in<bool>	prcTxByteGnt;

  void MonGen()
  {
    std::cout << sc_time_stamp() << " " << SIETxCtrl << " " << SIETxData << " " << SIETxFSRate << " " 
	    << SIETxReq << " " << SIETxWEn << " " << USBWireRdyIn << " " << clk << " " << prcTxByteCtrl << " "
	    << prcTxByteData << " " << prcTxByteFSRate << " " << prcTxByteReq << " " << prcTxByteWEn << " " << rst << "  $:" 
	    << SIETxGnt << " " << TxBits << " " << TxCtl << " " << TxFSRate << " " << USBWireRdyOut << " " << USBWireWEn << " " 
	    << prcTxByteGnt << std::endl;
  }

  SC_CTOR(monitor)
  {
    SC_METHOD(MonGen);
    sensitive << clk.pos();
  }
};

// here it goes.
int sc_main(int argc, char *argv[])
{
  sc_set_time_resolution(1, SC_NS);

  sc_signal<bool>	SIETxCtrl;
  sc_signal<sc_uint<2> >	SIETxData;
  sc_signal<bool>	SIETxFSRate;
  sc_signal<bool>	SIETxReq;
  sc_signal<bool>	SIETxWEn;
  sc_signal<bool>	USBWireRdyIn;
  sc_signal<bool>	clk;
  sc_signal<bool>	prcTxByteCtrl;
  sc_signal<sc_uint<2> >	prcTxByteData;
  sc_signal<bool>	prcTxByteFSRate;
  sc_signal<bool>	prcTxByteReq;
  sc_signal<bool>	prcTxByteWEn;
  sc_signal<bool>	rst;

  sc_signal<bool>	SIETxGnt;
  sc_signal<sc_uint<2> >	TxBits;
  sc_signal<bool>	TxCtl;
  sc_signal<bool>	TxFSRate;
  sc_signal<bool>	USBWireRdyOut;
  sc_signal<bool>	USBWireWEn;
  sc_signal<bool>	prcTxByteGnt;

  USBTxWireArbiter_L ins("ins");
	ins.SIETxCtrl(SIETxCtrl);
	ins.SIETxData(SIETxData);
	ins.SIETxFSRate(SIETxFSRate);
	ins.SIETxReq(SIETxReq);
	ins.SIETxWEn(SIETxWEn);
	ins.USBWireRdyIn(USBWireRdyIn);
	ins.clk(clk);
	ins.prcTxByteCtrl(prcTxByteCtrl);
	ins.prcTxByteData(prcTxByteData);
	ins.prcTxByteFSRate(prcTxByteFSRate);
	ins.prcTxByteReq(prcTxByteReq);
	ins.prcTxByteWEn(prcTxByteWEn);
	ins.rst(rst);
	ins.SIETxGnt(SIETxGnt);
	ins.TxBits(TxBits);
	ins.TxCtl(TxCtl);
	ins.TxFSRate(TxFSRate);
	ins.USBWireRdyOut(USBWireRdyOut);
	ins.USBWireWEn(USBWireWEn);
	ins.prcTxByteGnt(prcTxByteGnt);

  testt tb("tb");
	tb.SIETxCtrl(SIETxCtrl);
	tb.SIETxData(SIETxData);
	tb.SIETxFSRate(SIETxFSRate);
	tb.SIETxReq(SIETxReq);
	tb.SIETxWEn(SIETxWEn);
	tb.USBWireRdyIn(USBWireRdyIn);
	tb.clk(clk);
	tb.prcTxByteCtrl(prcTxByteCtrl);
	tb.prcTxByteData(prcTxByteData);
	tb.prcTxByteFSRate(prcTxByteFSRate);
	tb.prcTxByteReq(prcTxByteReq);
	tb.prcTxByteWEn(prcTxByteWEn);
	tb.rst(rst);

  monitor mon("mon");
	mon.SIETxCtrl(SIETxCtrl);
	mon.SIETxData(SIETxData);
	mon.SIETxFSRate(SIETxFSRate);
	mon.SIETxReq(SIETxReq);
	mon.SIETxWEn(SIETxWEn);
	mon.USBWireRdyIn(USBWireRdyIn);
	mon.clk(clk);
	mon.prcTxByteCtrl(prcTxByteCtrl);
	mon.prcTxByteData(prcTxByteData);
	mon.prcTxByteFSRate(prcTxByteFSRate);
	mon.prcTxByteReq(prcTxByteReq);
	mon.prcTxByteWEn(prcTxByteWEn);
	mon.rst(rst);
	mon.SIETxGnt(SIETxGnt);
	mon.TxBits(TxBits);
	mon.TxCtl(TxCtl);
	mon.TxFSRate(TxFSRate);
	mon.USBWireRdyOut(USBWireRdyOut);
	mon.USBWireWEn(USBWireWEn);
	mon.prcTxByteGnt(prcTxByteGnt);

  sc_trace_file *tf;
  tf = sc_create_vcd_trace_file("trace");

  sc_trace(tf, SIETxCtrl, "SIETxCtrl");
  sc_trace(tf, SIETxData, "SIETxData");
  sc_trace(tf, SIETxFSRate, "SIETxFSRate");
  sc_trace(tf, SIETxReq, "SIETxReq");
  sc_trace(tf, SIETxWEn, "SIETxWEn");
  sc_trace(tf, USBWireRdyIn, "USBWireRdyIn");
  sc_trace(tf, clk, "clk");
  sc_trace(tf, prcTxByteCtrl, "prcTxByteCtrl");
  sc_trace(tf, prcTxByteData, "prcTxByteData");
  sc_trace(tf, prcTxByteFSRate, "prcTxByteFSRate");
  sc_trace(tf, prcTxByteReq, "prcTxByteReq");
  sc_trace(tf, prcTxByteWEn, "prcTxByteWEn");
  sc_trace(tf, rst, "rst");

  sc_trace(tf, SIETxGnt, "SIETxGnt");
  sc_trace(tf, TxBits, "TxBits");
  sc_trace(tf, TxCtl, "TxCtl");
  sc_trace(tf, TxFSRate, "TxFSRate");
  sc_trace(tf, USBWireRdyOut, "USBWireRdyOut");
  sc_trace(tf, USBWireWEn, "USBWireWEn");
  sc_trace(tf, prcTxByteGnt, "prcTxByteGnt");

  sc_start(1000, SC_NS);
  sc_close_vcd_trace_file(tf);

  return 0;
}
