`include "usbTxWireArbiter.v"

module top ();

reg   SIETxCtrl;
reg   [1:0] SIETxData;
reg   SIETxFSRate;
reg   SIETxReq;
reg   SIETxWEn;
reg   USBWireRdyIn;
reg   clk;
reg   prcTxByteCtrl;
reg   [1:0] prcTxByteData;
reg   prcTxByteFSRate;
reg   prcTxByteReq;
reg   prcTxByteWEn;
reg   rst;

wire  SIETxGnt;
wire  [1:0] TxBits;
wire  TxCtl;
wire  TxFSRate;
wire  USBWireRdyOut;
wire  USBWireWEn;
wire  prcTxByteGnt;

// Clock generator
always
begin
  #5
  clk <= 1;
  #5
  clk <= 0;
end


initial begin
  $dumpfile ("usbTxWireArbiter.vcd");
  $dumpvars();
  rst <= 1;
  clk <= 0;

  SIETxData <= 1;
  prcTxByteData <= 2;

  SIETxCtrl <= 0;
  SIETxFSRate <= 0;
  SIETxReq <= 0;
  SIETxWEn <= 0;

  prcTxByteCtrl <= 0;
  prcTxByteFSRate <= 0;
  prcTxByteReq <= 0;
  prcTxByteWEn <= 0;


  #10
  rst <= 0;
  
  #10
  SIETxCtrl <= 1;
  SIETxFSRate <= 1;
  SIETxReq <= 1;
  SIETxWEn <= 1;

  #10
  prcTxByteCtrl <= 1;
  prcTxByteFSRate <= 1;
  prcTxByteReq <= 1;
  prcTxByteWEn <= 1;
  
  #10
  SIETxCtrl <= 0;
  SIETxFSRate <= 0;
  SIETxReq <= 0;
  SIETxWEn <= 0;
  
  #10
  SIETxCtrl <= 0;
  SIETxFSRate <= 1;
  SIETxReq <= 0;
  SIETxWEn <= 1;
  
  #10
  prcTxByteCtrl <= 1;
  prcTxByteFSRate <= 0;
  prcTxByteReq <= 1;
  prcTxByteWEn <= 0;
	
  #20 $finish;
end 

// Connect the DUT
USBTxWireArbiter U (
	SIETxCtrl,    
	SIETxData,
	SIETxFSRate,
	SIETxGnt,
	SIETxReq,
	SIETxWEn,
	TxBits,
	TxCtl,
	TxFSRate,
	USBWireRdyIn,
	USBWireRdyOut,
	USBWireWEn,
	clk,
	prcTxByteCtrl,
	prcTxByteData,
	prcTxByteFSRate,
	prcTxByteGnt,
	prcTxByteReq,
	prcTxByteWEn,
	rst
);

always @ (posedge clk)
begin 
  $display ("%d %b %d %b %b %b %b %b %b %d %b %b %b %b \t %b %d %b %b %b %b %b", $time, 
	SIETxCtrl,    
	SIETxData,
	SIETxFSRate,
	SIETxReq,
	SIETxWEn,
	USBWireRdyIn,
	clk,
	prcTxByteCtrl,
	prcTxByteData,
	prcTxByteFSRate,
	prcTxByteReq,
	prcTxByteWEn,
	rst,
	SIETxGnt,
	TxBits,
	TxCtl,
	TxFSRate,
	USBWireRdyOut,
	USBWireWEn,
	prcTxByteGnt);
end

endmodule
